diff --git a/contrib/pg_upgrade/server.c b/contrib/pg_upgrade/server.c
new file mode 100644
index c1d459d..94fc35e
*** a/contrib/pg_upgrade/server.c
--- b/contrib/pg_upgrade/server.c
*************** static void
*** 166,172 ****
  stop_postmaster_atexit(void)
  {
  	stop_postmaster(true);
- 
  }
  
  
--- 166,171 ----
*************** start_postmaster(ClusterInfo *cluster, b
*** 236,245 ****
  							  false,
  							  "%s", cmd);
  
  	if (!pg_ctl_return && !throw_error)
  		return false;
  
! 	/* Check to see if we can connect to the server; if not, report it. */
  	if ((conn = get_db_conn(cluster, "template1")) == NULL ||
  		PQstatus(conn) != CONNECTION_OK)
  	{
--- 235,261 ----
  							  false,
  							  "%s", cmd);
  
+ 	/* Did it fail and we are just testing if the server could be started? */
  	if (!pg_ctl_return && !throw_error)
  		return false;
  
! 	/*
! 	 * We set this here to make sure atexit() shuts down the server,
! 	 * but only if we started the server successfully.  We do it
! 	 * before checking for connectivity in case the server started but
! 	 * there is a connectivity failure.  If pg_ctl did not return success,
! 	 * we will exit below.
! 	 */
! 	if (pg_ctl_return)
! 		os_info.running_cluster = cluster;
! 
! 	/*
! 	 * pg_ctl -w might have failed because the server couldn't be started,
! 	 * or there might have been a connection problem in _checking_ if the
! 	 * server has started.  Therefore, even if pg_ctl failed, we continue
! 	 * and test for connectivity in case we get a connection reason for the
! 	 * failure.
! 	 */
  	if ((conn = get_db_conn(cluster, "template1")) == NULL ||
  		PQstatus(conn) != CONNECTION_OK)
  	{
*************** start_postmaster(ClusterInfo *cluster, b
*** 253,265 ****
  	}
  	PQfinish(conn);
  
! 	/* If the connection didn't fail, fail now */
  	if (!pg_ctl_return)
  		pg_log(PG_FATAL, "pg_ctl failed to start the %s server, or connection failed\n",
  			   CLUSTER_NAME(cluster));
  
- 	os_info.running_cluster = cluster;
- 
  	return true;
  }
  
--- 269,282 ----
  	}
  	PQfinish(conn);
  
! 	/*
! 	 * If pg_ctl failed, and the connection didn't fail, and throw_error is
! 	 * enabled, fail now.  This could happen if the server was already running.
! 	 */
  	if (!pg_ctl_return)
  		pg_log(PG_FATAL, "pg_ctl failed to start the %s server, or connection failed\n",
  			   CLUSTER_NAME(cluster));
  
  	return true;
  }
  
